Bug 20692: Extreme toggle checking for plack
[koha-equinox.git] / debian / scripts / koha-functions.sh
1 #!/bin/sh
2 #
3 # koha-functions.sh -- shared library of helper functions for koha-* scripts
4 # Copyright 2014 - Tomas Cohen Arazi
5 #                  Universidad Nacional de Cordoba
6 #
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
11 #
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #
17 # You should have received a copy of the GNU General Public License
18 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20
21 die()
22 {
23     echo "$@" 1>&2
24     exit 1
25 }
26
27 warn()
28 {
29     echo "$@" 1>&2
30 }
31
32 get_apache_config_for()
33 {
34     local site=$1
35     local sitefile="/etc/apache2/sites-available/$site"
36
37     if is_instance $site; then
38         if [ -f "$sitefile.conf" ]; then
39             echo "$sitefile.conf"
40         elif [ -f "$sitefile" ]; then
41             echo "$sitefile"
42         fi
43     fi
44 }
45
46 get_opacdomain_for()
47 {
48     local site=$1
49
50     if [ -e /etc/koha/koha-sites.conf ]; then
51         . /etc/koha/koha-sites.conf
52     else
53         echo "Error: /etc/koha/koha-sites.conf not present." 1>&2
54         exit 1
55     fi
56     local opacdomain="$OPACPREFIX$site$OPACSUFFIX$DOMAIN"
57     echo "$opacdomain"
58 }
59
60 get_intradomain_for()
61 {
62     local site=$1
63
64     if [ -e /etc/koha/koha-sites.conf ]; then
65         . /etc/koha/koha-sites.conf
66     else
67         echo "Error: /etc/koha/koha-sites.conf not present." 1>&2
68         exit 1
69     fi
70     local intradomain="$INTRAPREFIX$site$INTRASUFFIX$DOMAIN"
71     echo "$intradomain"
72 }
73
74 letsencrypt_get_opacdomain_for()
75 {
76     local site=$1
77
78     if [ -e /var/lib/koha/$site/letsencrypt.enabled ]; then
79         . /var/lib/koha/$site/letsencrypt.enabled
80     else
81         local opacdomain=$(get_opacdomain_for $site)
82     fi
83     echo "$opacdomain"
84 }
85
86 is_enabled()
87 {
88     local site=$1
89     local instancefile=$(get_apache_config_for $site)
90
91     if [ "$instancefile" = "" ]; then
92         return 1
93     fi
94
95     if grep -q '^[[:space:]]*Include /etc/koha/apache-shared-disable.conf' \
96             "$instancefile" ; then
97         return 1
98     else
99         return 0
100     fi
101 }
102
103 is_instance()
104 {
105     local instancename=$1
106
107     if find -L /etc/koha/sites -mindepth 1 -maxdepth 1 \
108                          -type d -printf '%f\n'\
109           | grep -q -x "$instancename" ; then
110         return 0
111     else
112         return 1
113     fi
114 }
115
116 is_email_enabled()
117 {
118     local instancename=$1
119
120     if [ -e /var/lib/koha/$instancename/email.enabled ]; then
121         return 0
122     else
123         return 1
124     fi
125 }
126
127 is_letsencrypt_enabled()
128 {
129     local instancename=$1
130
131     if [ -e /var/lib/koha/$instancename/letsencrypt.enabled ]; then
132         return 0
133     else
134         return 1
135     fi
136 }
137
138 is_sip_enabled()
139 {
140     local instancename=$1
141
142     if [ -e /etc/koha/sites/$instancename/SIPconfig.xml ]; then
143         return 0
144     else
145         return 1
146     fi
147 }
148
149 is_sitemap_enabled()
150 {
151     local instancename=$1
152
153     if [ -e /var/lib/koha/$instancename/sitemap.enabled ]; then
154         return 0
155     else
156         return 1
157     fi
158 }
159
160 is_sip_running()
161 {
162     local instancename=$1
163
164     if daemon --name="$instancename-koha-sip" \
165             --pidfiles="/var/run/koha/$instancename/" \
166             --user="$instancename-koha.$instancename-koha" \
167             --running ; then
168         return 0
169     else
170         return 1
171     fi
172 }
173
174 is_zebra_running()
175 {
176     local instancename=$1
177
178     if daemon --name="$instancename-koha-zebra" \
179             --pidfiles="/var/run/koha/$instancename/" \
180             --user="$instancename-koha.$instancename-koha" \
181             --running ; then
182         return 0
183     else
184         return 1
185     fi
186 }
187
188 is_indexer_running()
189 {
190     local instancename=$1
191
192     if daemon --name="$instancename-koha-indexer" \
193             --pidfiles="/var/run/koha/$instancename/" \
194             --user="$instancename-koha.$instancename-koha" \
195             --running ; then
196         return 0
197     else
198         return 1
199     fi
200 }
201
202 is_plack_enabled_opac()
203 {
204     local instancefile=$1
205
206     if [ "$instancefile" = "" ]; then
207         return 1
208     fi
209
210     # remember 0 means success/true in bash.
211     if grep -q '^[[:space:]]*Include /etc/koha/apache-shared-opac-plack.conf' \
212             "$instancefile" ; then
213         return 0
214     else
215         return 1
216     fi
217 }
218
219 is_plack_enabled_intranet()
220 {
221     local instancefile=$1
222
223     if [ "$instancefile" = "" ]; then
224         return 1
225     fi
226
227     # remember 0 means success/true in bash.
228     if grep -q '^[[:space:]]*Include /etc/koha/apache-shared-intranet-plack.conf' \
229             "$instancefile" ; then
230         return 0
231     else
232         return 1
233     fi
234 }
235
236 is_plack_enabled()
237 {
238     local site=$1
239     local instancefile=$(get_apache_config_for $site)
240
241     if [ "$instancefile" = "" ]; then
242         return 1
243     fi
244
245     if is_plack_enabled_opac $instancefile ; then
246         enabledopac=1
247     else
248         enabledopac=0
249     fi
250     if is_plack_enabled_intranet $instancefile ; then
251         enabledintra=1
252     else
253         enabledintra=0
254     fi
255
256     # remember 0 means success/true in bash.
257     if [ "$enabledopac" != "$enabledintra" ] ; then
258         echo "$site has a plack configuration error. Enable or disable plack to correct this."
259         return 0
260     elif [ "$enabledopac" = "1" ] ; then
261         return 0
262     else
263         return 1
264     fi
265 }
266
267 is_plack_running()
268 {
269     local instancename=$1
270
271     if start-stop-daemon --pidfile "/var/run/koha/${instancename}/plack.pid" \
272             --status ; then
273         return 0
274     else
275         return 1
276     fi
277 }
278
279 adjust_paths_dev_install()
280 {
281 # Adjust KOHA_HOME, PERL5LIB for dev installs, as indicated by
282 # corresponding tag in koha-conf.xml
283
284     local instancename=$1
285     local dev_install=""
286
287     if [ "$instancename" != "" ] && is_instance $instancename; then
288         dev_install=$(run_safe_xmlstarlet $instancename dev_install)
289     fi
290
291     if [ "$dev_install" != "" ] && [ "$dev_install" != "0" ]; then
292         DEV_INSTALL=1
293         KOHA_HOME=$(run_safe_xmlstarlet $instancename intranetdir)
294         PERL5LIB=$KOHA_HOME
295     else
296         DEV_INSTALL=""
297     fi
298 }
299
300 get_instances()
301 {
302     find -L /etc/koha/sites -mindepth 1 -maxdepth 1\
303                          -type d -printf '%f\n' | sort
304 }
305
306 get_loglevels()
307 {
308     local instancename=$1
309     local retval=$(run_safe_xmlstarlet $instancename zebra_loglevels)
310     if [ "$retval" != "" ]; then
311         echo "$retval"
312     else
313         echo "none,fatal,warn"
314     fi
315 }
316
317 get_max_record_size()
318 {
319     local instancename=$1
320     local retval=$(xmlstarlet sel -t -v 'yazgfs/config/zebra_max_record_size' /etc/koha/sites/$instancename/koha-conf.xml)
321     if [ "$retval" != "" ]; then
322         echo "$retval"
323     else
324         echo "1024"
325     fi
326 }
327
328 get_tmpdir()
329 {
330     if [ "$TMPDIR" != "" ]; then
331         if [ -d "$TMPDIR" ]; then
332             echo $TMPDIR
333             return 0
334         fi
335         # We will not unset TMPDIR but just default to /tmp here
336         # Note that mktemp (used later) would look at TMPDIR
337         echo "/tmp"
338         return 0
339     fi
340     local retval=$(mktemp -u)
341     if [ "$retval" = "" ]; then
342         echo "/tmp"
343         return 0
344     fi
345     echo $(dirname $retval)
346 }
347
348 run_safe_xmlstarlet()
349 {
350     # When a bash script sets -e (errexit), calling xmlstarlet on an
351     # unexisting key would halt the script. This is resolved by calling
352     # this function in a subshell. It will always returns true, while not
353     # affecting the exec env of the caller. (Otherwise, errexit is cleared.)
354     local instancename=$1
355     local myexpr=$2
356     set +e; # stay on the safe side
357     echo $(xmlstarlet sel -t -v "yazgfs/config/$myexpr" /etc/koha/sites/$instancename/koha-conf.xml)
358     return 0
359 }